// Vector.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
using namespace std;
// Detalhes na pg. 930 do Livro dos Deitels

template < class T >
void imprimeVetor ( vector< T > &Vetor);

int _tmain(int argc, _TCHAR* argv[])
{
	const int TAMANHO = 6;

	int a[ TAMANHO ] = { 1, 2, 3, 4, 5, 6};

	vector<int> Vetor;

	cout	<< "O tamanho inicial de Vetor : " << Vetor.size() << endl
			<< "A capacidade inicial de Vetor : " << Vetor.capacity() << endl;


	Vetor.push_back( 2 );
	Vetor.push_back( 3 );
	Vetor.push_back( 4 );

	//Vetor.p

	cout	<< "O tamanho de Vetor : "		<< Vetor.size() << endl
			<< "A capacidade de Vetor : "	<< Vetor.capacity() << endl << endl;

	cout	<< "Contedo do array a usando notao de ponteiro: " << endl;

	for (int *ptr = a; ptr != a + TAMANHO; ++ptr)
	{
		cout << *ptr << ' ';
	}
    cout << endl << endl;

	cout << "Contedo do Vetor usando a notao de iterador: ";
	imprimeVetor( Vetor );
	cout << endl << endl;

	cout << "Contedo do Vetor invertido: ";
	vector<int>::reverse_iterator Iterador;

	for ( Iterador = Vetor.rbegin(); Iterador != Vetor.rend(); ++Iterador )
	{
		cout << *Iterador << ' ';
	}
	cout << endl << endl;

    /*Vetor.clear();
	cout << "Contedo do Vetor aps clear: ";
	imprimeVetor( Vetor );  */

	Vetor.push_back(1);
	Vetor.push_back(1);
	Vetor.push_back(1);
	Vetor.push_back(1);
	Vetor.push_back(1);
	Vetor.push_back(1);
	Vetor.push_back(1);
	imprimeVetor( Vetor );

	for ( Iterador = Vetor.rbegin(); Iterador != Vetor.rend(); ++Iterador )
	{
		*Iterador = 9;
	}
	cout << endl << endl;
	imprimeVetor( Vetor ); 


	return 0;
}

template < class T >
void imprimeVetor( vector< T > &Vetor)
{
	vector< T >::const_iterator Iterador2;

	for ( Iterador2 = Vetor.begin(); Iterador2 != Vetor.end(); Iterador2++ )
	{
		cout << *Iterador2 << ' ';
	}
}
