// Lista.cpp : Defines the entry point for the console application.
//

// OBSERVAO, no deixe de olhar o stdafx.h

#include "stdafx.h" 
using namespace std;

// Cabealho para a funo 'genrica' capaz de imprimir uma lista.
template <class T>
void imprimeLista( const list<T> &listaRef );

// Funo main pr-criada na criao de projeto Win32 console no Express Edition.
int _tmain(int argc, _TCHAR* argv[])
{
	// Define uma constante;
    const int TAM = 4;

	// Define um vetor, inicializando-o;
	int a [ TAM ] = { 2, 6, 4, 8 };

	// Define duas lista a partir da classe 'list' do STL (Standard Template Library)
	// A 'list' do STL  um template e aqui este template  
	// parametrizado com a classe 'int'.
	list<int> valores, outrosValores;

	//list<int>::iterator i; 
	

	// *************************************************
	// Adiciona elementos a lista a partir de seu comeo.
	valores.push_front( 1 );
	valores.push_front( 2 );
	// Adiciona elementos a lista a partir de seu fim.
	valores.push_back ( 4 );
	valores.push_back ( 3 );

	// Imprime os elementos da lista via a funo printList().
	cout << "Values contm: "; 
	imprimeLista( valores ); 
	cout << endl << endl;
	
	// *************************************************
	// Ordena os elementos da lista.
	valores.sort();
	// Imprime os elementos da lista via a funo printList().
	cout << "Values aps o 'sort' contm: "; 
	imprimeLista( valores );
	cout << endl << endl;

	return 0;
}

// Implementao da funo genrica capaz de imprimir uma lista
template <class T>
void imprimeLista( const list<T> &listaRef )
{	// Testa se a lista est vazia.
    if ( listaRef.empty() )
	{
		cout << "Lista est vazia." << endl;
	}
	else
	{
		// Cria um iterado, isto , um objeto que  capaz de receber
		// um 'ponteiro inicial' e um 'ponteiro final' de uma lista e,
		// a partir da, imprimir todos os elementos da lista.

		// O interador exige um objeto de sada... Neste caso
		// usamos o cout que, na verdade,  um objeto denido em <stream>
		// Ainda, pode-se adicionar um texto entre cada elemento impresso.

		ostream_iterator< T > Saida ( cout, " " );

		// Este comando o interador Saida receber o 'ponteiro inicial'
		// bem como o 'ponteiro final'.
		copy( listaRef.begin(), listaRef.end(), Saida );
	}
}
