// VectorB.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
using namespace std;

int _tmain(int argc, _TCHAR* argv[])
{
	const int TAMANHO = 6;
	
	int a[TAMANHO]= { 1, 2, 3, 4, 5, 6 };

	vector<int> Vetor (a, a + TAMANHO );

	ostream_iterator<int> Saida( cout, " " );

	cout	<< "O Vetor contm : ";

	copy( Vetor.begin(), Vetor.end(), Saida);

	cout	<< endl << endl;

	cout	<< "Primeiro elemento de Vetor: "	
			<< Vetor.front()	
			<< endl

			<< "Ultimo elemento de Vetor: "		
			<< Vetor.back()		
			<< endl << endl;

	// Atribui 7 ao primeiro elemento
	Vetor[ 0 ] = 7;	
	cout	<< "Contedo do Vetor aps primeira mudana: ";
	copy( Vetor.begin(), Vetor.end(), Saida);
	cout << endl;
	
	cout	<< "A capacidade do Vetor neste momento eh: " 
			<< Vetor.capacity() << endl;
	cout	<< "O tamanho do Vetor neste momento eh: " 
			<< Vetor.size() << endl;
	cout	<< endl << endl;

	// Atribui 10 ao elemento na posio 2
	Vetor.at(2) = 10;						
	cout	<< "Contedo do Vetor aps segunda mudana: ";
	copy( Vetor.begin(), Vetor.end(), Saida);
	cout	<< endl << endl;

	cout	<< "A capacidade do Vetor neste momento eh: "
			<< Vetor.capacity() << endl;
	cout	<< "O tamanho do Vetor neste momento eh: "
			<< Vetor.size() << endl;
	cout	<< endl << endl;

	// insere 22 como segundo elemento.
	Vetor.insert(Vetor.begin() + 1, 22);
	cout	<< "Contedo do Vetor aps terceira mudana: ";
	copy( Vetor.begin(), Vetor.end(), Saida);
	cout	<< endl;
	cout	<< "A capacidade do Vetor neste momento eh: "
			<< Vetor.capacity() << endl;
	cout	<< "O tamanho do Vetor neste momento eh: "
			<< Vetor.size() << endl;
	cout	<< endl << endl;

	try
	{
			// acessa elemento fora do intervalo vlido
			Vetor.at(100) = 777;
	}
	catch ( std::out_of_range e )
	{
			cout << "Exceo: " << e.what() 
				 << endl << endl;
	}

	Vetor.erase( Vetor.begin() );
	//
	cout	<< "Contedo do Vetor aps erase: ";
	std::copy( Vetor.begin(), Vetor.end(), Saida);
	cout	<< endl << endl ;

	//cout	<< "Contedo do Vetor aps Segundo erase: ";
	//Vetor.erase( Vetor.begin()+2, Vetor.end() );
	//std::copy( Vetor.begin(), Vetor.end(), Saida);
	//cout	<< endl << endl ;

	Vetor.erase( Vetor.begin(), Vetor.end() );
	cout	<< "Aps erase, o Vetor: "
			// operador ? :  equivalente a if else
			<< (Vetor.empty() ? " est " : " no est ")   
			<< "vazio." << endl << endl; 

	Vetor.insert( Vetor.begin(), a, a + TAMANHO );
	//Vetor.end();

	cout	<< "Contedo do Vetor aps isert (antes de clear):";
	std::copy( Vetor.begin(), Vetor.end(), Saida);
	cout	<< endl << endl;

	// clear chama erase para esvaziar uma coleo
	Vetor.clear(); 
	cout	<< "Aps o 'clear', o Vetor"
			<< ( Vetor.empty() ? "est" : "no est")
			<< "vazio" << endl << endl;

	return 0;
}

